Redmine - Defect #12510

Issues PDF export: Spent time/Float-values aren’t rounded to 2 digits
2012-12-05 11:39 - Lubo$ Schramek

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version: 4.0.0

Resolution: Fixed Affected version: 2.6.0
Description

Hello,

How to simulate problem?

e add Spent time column to issues
e modify Spent time in some issue to 2.45
e export table to PDF

There will be a columns Spent time with 2.45000004768372. | hope there are missing some number format func(), can you please fix
this problem? | am making these exports for customers and it looks bad.

Thanks.

Related issues:

Related to Redmine - Defect #13780: Spent hours have excessive flaction in PD... Closed
Related to Redmine - Defect #28233: IssuesPdfHelperTest fails when run in iso... Closed

Associated revisions

Revision 17059 - 2017-12-06 15:25 - Go MAEDA
Fix: Round floats to 2 digits when rendering an issue list to PDF (#12510).

Patch by Holger Just and Marius BALTEANU.

Revision 17063 - 2017-12-07 12:46 - Toshi MARUYAMA

svn propset svn:eol-style native test/unit/lib/redmine/export/pdf/issues_pdf_test.rb (#12510)
Revision 17065 - 2017-12-07 13:03 - Toshi MARUYAMA
code clean up IssuesPdfHelperTest (#12510)

e remove extra empty lines

¢ remove trailing white space
* replace tab to two spaces

Revision 17077 - 2017-12-07 15:28 - Toshi MARUYAMA
add copyright header to test/unit/lib/redmine/helpers/url_test.rb (#12510)

Revision 17212 - 2018-02-24 10:26 - Go MAEDA
Add minimal fixture for issues_pdf_test (#12510).

Patch by Gregor Schmidt.

History

#1 - 2012-12-07 07:07 - fangzheng (0 0)
- File export.pdf added

Mark. Waiting for solution.
BTW, this issue doesn't occur on CSV.
#2 - 2013-01-27 17:59 - Filou Centrinov

I'm seeing the same problem in Redmine 2.2.1.
In my Database the spent time values is for example 0.1, but the pdf export displays 0.100000001490116.

#3 - 2013-01-27 22:13 - Daniel Felix
Maybe this relates to the float_max like #126807?

#4 - 2013-01-27 22:13 - Daniel Felix
- Priority changed from High to Normal

#5 - 2013-01-28 04:00 - Filou Centrinov
Daniel Felix wrote:

Maybe this relates to the float_max like #126807?

Yes-ebviously-beth-bugs{this ticketand-#12680)-have-the-same-causation{Hoatingpeint-error):

e 0.1 -> IEEE754 Single precision 32-bit
® 999999999999999999999999999999 -> IEEE754 Single precision 32-bit

UPDATE: No. It does not relate to #12680.

#6 - 2013-02-12 01:59 - Filou Centrinov

- File pdf.patch added

To get pretty float values for spent time and estimated time | created this patch: /lib/redmine/export/ pdf.patch

If the value is empty or zero the pdf cell keeps empty, so you get a better overview on spent and estimated hours.
Could you merge this to redmine?

#7 - 2013-02-19 15:21 - Filou Centrinov

Please, could you fix this with redmine 2.3?

#8 - 2013-02-19 16:46 - Daniel Felix

Filou Centrinov wrote:

UPDATE: No. It does not relate to #12680.

Why not? It seems for me to be again some floating point error, which we've encounter many times in different systems.

#9 - 2013-02-19 18:11 - Filou Centrinov
Daniel Felix wrote:
Why not? It seems for me to be again some floating point error, which we've encounter many times in different systems.

The difference is: In #12680 the number is too big, so the floating precision can not be provided. In this issue we are within the floating precision, so
the correct presentation should be provided.

The problem is internal caused by displaying a value with a higher precision then the value originaly had. So 0.1 becomes 0.1000000014901186,
because the type of variable had a precision of 32bit that allows only 8 positions after decimal point. Therefore this problem can easly fixed by: "%.2f"
% value

See: pdf.rb.patch

#10 - 2013-02-20 14:30 - Filou Centrinov

In /lib/redmine/i18n.rb is a function called |_hours to format hours into a value+label string. If this function would'nt be used in
/app/view/issues/show.html.erb you get the same effect of displayed spent time.

So I_hours fixes the same "bug", but with an additional label.

#11 - 2013-03-06 12:37 - Filou Centrinov
- File pdf.rb.patch added
#12 - 2013-07-15 20:59 - Filou Centrinov

Please fix this. It's a small fix. ... or make it to a candidate.

#13 - 2013-07-16 08:31 - Etienne Massip
- Status changed from New to Confirmed

- Target version set to Candidate for next minor release

I can confirm the defect although I'm not fond of the patch, is it possible to fix every single float value display at once rather than specific attributes?

Edit: confirmed with MRI 1.9.3

#14 - 2013-08-05 09:55 - David Lukas Miiller

+1
For the particular issue I've observed that on Redmine 2.3.1 | had the following time entries:

® 3.50h
e 1.25h
e 0.30h (I think I've entered "0:20")
And that is what | see:
¢ 5.05 with Web User Interface (HTML) --> good

¢ 5.050000011920929 with PDF-Export --> chould be improved
e "spent_hours":5.050000011920929 with REST API (JSON) using http://myhost/redmine/issues/1234.json --> chould be improved

#15 - 2013-08-05 12:06 - Toshi MARUYAMA
- File web-edit.png added

David Lukas Muller wrote:

e 5.05 with Web User Interface (HTML) --> good

Web edit form has same problem.
Due date [ l

Estimated time (1 11711111 Hours

#16 - 2013-08-05 12:09 - Toshi MARUYAMA

You can see by following change.

diff --git a/app/views/issues/_attributes.html.erb b/app/views/issues/_attributes.html.erb
--— a/app/views/issues/_attributes.html.erb
+++ b/app/views/issues/_attributes.html.erb
@@ -63,7 +63,7 @@
<% end %>

<% if @issue.safe_attribute? 'estimated_hours' %>
—<p><%= f.text_field :estimated_hours, :size => 3, :disabled => !Q@issue.leaf?, :required => (@issue.required_at

tribute? ('estimated_hours') %> <%= 1(:field_hours) $%$></p>
+<p><%= f.text_field :estimated_hours, :size => 6, :disabled => !Q@issue.leaf?, :required => (@issue.required_at
tribute? ('estimated_hours') %> <%= 1 (:field_hours) %></p>

<% end %>
<% 1f Q@issue.safe_attribute? ('done_ratio') && @issue.leaf? && Issue.use_field for_done_ratio? %>

#17 - 2014-10-29 15:35 - Holger Just
- File 0001-Round-floats-to-2-digits-when-rendering-an-issue-lis.patch added

The attached patch (which was extracted from Planio) fixes this issue for all float values in table cells. This patch thus addresses the concerns of
Etienne above.

The patch works agains current trunk but should apply similarly to earlier versions. The used method is the one used in the
QueriesHelper#column_value method and thus should produce results similar to it.
https://plan.io

#18 - 2014-10-29 15:39 - Jan from Planio www.plan.io

- Assignee set to Jean-Baptiste Barth

In case you were still looking for easy fixes :)

#19 - 2014-11-02 23:07 - Jean-Baptiste Barth
- Affected version changed from 2.1.2 to 2.6.0

I do :) First I'll try to add some tests to this part of the code but no pb I'll merge it after.

#20 - 2016-12-19 17:17 - Olivier Houdas

Tested on 3.3.1, still occurs.

#21 - 2017-11-15 14:38 - S. Ruttloff

Problem still exists in Redmine 3.3.2, but could fix it here:
/lib/redmine/export/pdf/issues_pdf_helper.rb

Search for

if value.is_a? (Date)
format_date (value)
elsif value.is_a? (Time)
format_time (value)
else
value
end

and replace by

if value.is_a? (Date)
format_date (value)
elsif value.is_a? (Time)
format_time (value)
elsif value.is_a? (Float)
sprintf "%.2f", value
else
value
end

#22 - 2017-11-27 01:47 - Marius BALTEANU

- File 0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17037.patch added
- File before.png added

- File after.png added

- Assignee deleted (Jean-Baptiste Barth)

Tested on current trunk (r17037) and the issue still occurs.

I've updated the patch from Holger Just to apply cleanly. | think that we can fix this issue in the next release.

Before:
before.png

After:
after.png

#23 - 2017-12-05 08:54 - Mischa The Evil

We might want some test coverage added if there isn't any yet, as Jean-Baptiste already suggested.

#24 - 2017-12-05 23:18 - Marius BALTEANU
- File deleted (0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17037.patch)

#25 - 2017-12-05 23:20 - Marius BALTEANU
https://www.redmine.org/projects/redmine/repository/svn/revisions/17037

- File 0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.patch added

Mischa The Evil wrote:

We might want some test coverage added if there isn't any yet, as Jean-Baptiste already suggested.

Attached an updated patch that contains the fix and a test strictly for this scenario. On top of this patch, we can add more tests in the future to
improve the coverage.

#26 - 2017-12-06 00:30 - Mischa The Evil
- Subject changed from Issues PDF export - Spent time to Issues PDF export: Spent time/Float-values aren't rounded to 2 digits.

- Target version changed from Candidate for next minor release to 4.1.0

Thanks Holger and Marius.

#27 - 2017-12-06 07:43 - Marius BALTEANU
- File deleted (0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.patch)

#28 - 2017-12-06 07:43 - Marius BALTEANU

- File 0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.patch added

| had a typo in my previous patch.

Maybe we can deliver this fix earlier than Redmine 4.

#29 - 2017-12-06 13:30 - Go MAEDA

Marius, thank you for adding a test. But | encountered the following error. Could you look into it?

$ ruby test/unit/lib/redmine/export/pdf/issues_pdf_test.rb
Run options: —--seed 32491

# Running:
F
Failure:

IssuesPdfHelperTest#test_fetch_row_values_should_round_float_values [test/unit/lib/redmine/export/pdf/issues_p
df_test.rb:32]:

—-—— expected
+++ actual
@@ -1 +1 Q@

—-["2", "Add ingredients categories", "4.34"]
+["2", "Add ingredients categories", "0.00"]

bin/rails test test/unit/lib/redmine/export/pdf/issues_pdf_test.rb:23

Finished in 0.658523s, 1.5185 runs/s, 1.5185 assertions/s.
1 runs, 1 assertions, 1 failures, 0 errors, 0 skips

#30 - 2017-12-06 14:28 - Marius BALTEANU
- File deleted (0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.patch)

#31 - 2017-12-06 14:32 - Marius BALTEANU
- File 0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.patch added

It should be fine now.

#32 - 2017-12-06 15:31 - Go MAEDA

- Status changed from Confirmed to Closed
- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 4.0.0

- Resolution set to Fixed
Committed in the trunk (r17059). Thank you.

#33 - 2017-12-17 06:27 - Toshi MARUYAMA

- Subject changed from Issues PDF export: Spent time/Float-values aren't rounded to 2 digits. to Issues PDF export: Spent time/Float-values aren't

rounded to 2 digits

#34 - 2018-02-22 11:30 - Marius BALTEANU
- Related to Defect #28233: IssuesPdfHelperTest fails when run in isolation added

#35 - 2018-02-24 10:35 - Go MAEDA

A fix for issues_pdf_test was submitted as #28233. | committed the fix in r17212.

Files

export.pdf 311 KB 2012-12-07 fangzheng (00)
pdf.patch 436 Bytes 2013-02-12 Filou Centrinov
pdf.rb.patch 531 Bytes 2013-03-06 Filou Centrinov
web-edit.png 4.52 KB 2013-08-05 Toshi MARUYAMA
0001-Round-floats-to-2-digits-when-rendering-an-issue-lis.patch 739 Bytes 2014-10-29 Holger Just
before.png 79.7 KB 2017-11-27 Marius BALTEANU
after.png 63.8 KB 2017-11-27 Marius BALTEANU
0001-Round-floats-to-2-digits-when-rendering-an-issue-lis_r17055.pat¢h21 KB 2017-12-06 Marius BALTEANU
